"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.construct = construct;
exports.unmarshallAll = unmarshallAll;
exports.unmarshallAndConvert = unmarshallAndConvert;
exports.mapTransactionUpdateItem = mapTransactionUpdateItem;
const util_dynamodb_1 = require("@aws-sdk/util-dynamodb");
const class_transformer_1 = require("class-transformer");
const enums_1 = require("../enums/enums");
function construct() {
    var type;
    return type;
}
function unmarshallAll(items) {
    var newItems = [];
    for (let item of items) {
        var newItem = (0, util_dynamodb_1.unmarshall)(item);
        newItems.push(newItem);
    }
    return newItems;
}
function unmarshallAndConvert(item) {
    var unmarshalled = (0, util_dynamodb_1.unmarshall)(item);
    return (0, class_transformer_1.plainToInstance)(construct(), unmarshalled);
}
function mapTransactionUpdateItem(table, key, values) {
    var updateExpression = [];
    var expressionAttributeNames = {};
    var expressionAttributeValues = {};
    for (let [key, value] of Object.entries(values)) {
        updateExpression.push('#' + key + ' = :' + key);
        expressionAttributeNames['#' + key] = key;
        expressionAttributeValues[':' + key] = value;
    }
    return {
        type: enums_1.DynamoWriteOperationType.UPDATE,
        table: table,
        key: key,
        update_expression: 'SET ' + updateExpression.join(', '),
        expression_attribute_names: expressionAttributeNames,
        expression_attribute_values: expressionAttributeValues,
    };
}
